/**
 * @function follow
 * @description 关注店铺
 * @param {string} supplier_id 店铺唯一标识
 */
function follow(supplier_id) {
    ajax({
        data : {
            script_name : 'user',
            act : 'add_guanzhu',
            suppId : supplier_id,
        },
        success : cb_follow,
        type : 'GET',
    })
}

/**
 * @function cb_follow
 * @description 关注店铺回调函数
 * @param {string} data 服务器端返回的数据
 */
function cb_follow(data) {
    json = parse_result(data)
    if (json) {
        if (json.error <= 0) {
            var supplier_id = json.supplier_id
            open_toast(json.content)
            $('#shop_focus').html('已关注')
            $('#follow_supplier_button').addClass('followed')
            $('#follow_button').html('取消关注').addClass('followed')
            $('#shop_' + supplier_id).find('.follow_button').first().html('已关注').addClass('followed')
            publish(CHANNEL_FOLLOW_SUPPLIER, supplier_id)
        }
    }
}

/**
 * @function unfollow
 * @description 取消关注店铺
 * @param {string} supplier_id 店铺唯一标识
 */
function unfollow(supplier_id) {
    ajax({
        data : {
            script_name : 'user',
            act : 'del_follow',
            supplier_id : supplier_id,
        },
        success : cb_unfollow,
        type : 'GET',
    })
}

/**
 * @function cb_unfollow
 * @description 取消关注店铺回调函数
 * @param {string} data 服务器端返回的数据
 */
function cb_unfollow(data) {
    json = parse_result(data)
    if (json) {
        if (json.error <= 0) {
            var supplier_id = json.supplier_id
            open_toast(json.content)
            $('#follow_supplier_button').removeClass('followed')
            $('#shop_focus').html('关注店铺')
            $('#follow_button').attr('follow_id', '').html('+加关注').removeClass('followed')
            $('#shop_' + supplier_id).attr('follow_id', '').find('.follow_button').first().html('关注').removeClass('followed')
            publish(CHANNEL_UNFOLLOW_SUPPLIER, supplier_id)
        }
    }
}