(function($) {
    var _options = {
        type : ['up'],
        up_color : '#FFF',
        up_func : _up_func,
        up_text_color : '#530606',
        up_pull_text : '拖动刷新',
        up_release_text : '释放刷新',
        up_loading_text : '刷新中，请稍等',
        up_image : 'res://reload.png',
        down_color : '#FFF',
        down_func : _down_func,
        down_text_color : '#530606',
        down_pull_text : '拖动加载更多内容',
        down_release_text : '释放加载',
        down_loading_text : '加载中，请稍等',
        down_image : 'res://reload.png',
        cb_up_func : _cb_up_func,
        cb_down_func : _cb_down_func,
        cb_down_init : _cb_down_init,
        scroller : '#content_container',
    },
        _initialized = false

    var _init = function(options) {
        $.extend(_options, options)

        if ($.inArray('up', _options.type) != -1) {
            var image_settings = {
                imagePath : _options.up_image,
                textColor : _options.up_text_color,
                pullToReloadText : _options.up_pull_text,
                releaseToReloadText : _options.up_release_text,
                loadingText : _options.up_loading_text,
            }
            appcan.window.setBounce({
                bounceType : '0',
                color : _options.up_color,
                upEndCall : _empty,
                downEndCall : _devide_func,
                imgSettings : JSON.stringify(image_settings),
            })
            _initialized = true
        }
        if ($.inArray('down', _options.type) != -1) {
            var image_settings = {
                imagePath : _options.down_image,
                textColor : _options.down_text_color,
                pullToReloadText : _options.down_pull_text,
                releaseToReloadText : _options.down_release_text,
                loadingText : _options.down_loading_text,
            }
            appcan.window.setBounce({
                bounceType : '1',
                color : _options.down_color,
                upEndCall : _empty,
                downEndCall : _devide_func,
                imgSettings : JSON.stringify(image_settings),
            })
            _initialized = true
        }
    }
    var _reset = function() {
        if (!_initialized) {
            return false
        }
        if ($.inArray('up', _options.type) != -1) {
            appcan.window.resetBounceView(0)
        }
        if ($.inArray('down', _options.type) != -1) {
            appcan.window.resetBounceView(1)
        }
    }
    var _get = function(key) {
        return _options[key]
    }
    var _set = function(key, val) {
        if ($.isPlainObject(key)) {
            $.extend(_options, key)
        } else {
            _options[key] = val
        }
    }
    var _empty = function() {

    }
    var _devide_func = function(type) {
        switch(type) {
        case 0:
            _options.up_func(type)
            break
        case 1:
            _options.down_func(type)
            break
        }
    }
    function _up_func(type) {
        if ( typeof page_param['page'] != 'undefined') {
            page_param['page'] = 1
        }
        if ( typeof page_param['is_full_page'] != 'undefined') {
            page_param['is_full_page'] = 1
        }
        page_callback = cb_reload
        page_loading = false
        reload()
    }

    function _cb_up_func() {

    }

    function _cb_down_init() {

    }

    function _down_func(type) {
        if ( typeof page_param == 'undefined' || typeof page_param['page'] == 'undefined' || typeof page_param['is_full_page'] == 'undefined') {
            return
        }
        page_param['page']++
        page_param['is_full_page'] = 0
        page_callback = $.bounce.get('cb_down_func')
        page_loading = false
        reload()
    }

    function _cb_down_func(data) {
        var json = parse_result(data)
        if (json) {
            if (json.error == ERR_END_OF_LIST) {
                open_toast(json.message)
            } else {
                if (page_param['page'] == '1') {
                    $($.bounce.get('scroller')).html(json.content)
                } else {
                    $($.bounce.get('scroller')).append(json.content)
                }
                $.bounce.get('cb_down_init')()
            }
        }
    }

    function _disable() {
        if (_initialized) {
            appcan.window.disableBounce()
        }
    }

    function _enable() {
        if (_initialized) {
            appcan.window.enableBounce()
        }
    }

    $(function() {
        $.bounce = {
            init : _init,
            set : _set,
            get : _get,
            end : _reset,
            disable : _disable,
            enable : _enable,
        }
    })
})(Zepto)
