(function($) {
    var _options = {
        id : 'ajax_loading',
        duration : DUR_ANIMATION,
        z_index : '1000',
        image : './img/ajax-loading2.gif',
        message : '',
    }

    function _start(options) {
        if ($('#' + _options.id).length == 0) {
            _init(options)
        }
        var selector = '#' + _options.id
        $(selector).addClass('start')
        $(selector).css('display', '')
    }

    function _end(options) {
        if ($('#' + _options.id).length == 0) {
            _init(options)
        }
        var selector = '#' + _options.id
        $(selector).removeClass('start')
        setTimeout(function() {
            $(selector).css('display', 'none')
        }, _options.duration)
    }

    function _init(options) {
        if ($('#' + _options.id).length == 0) {
            $.extend(_options, options)
            var css_arr = ['display: none', 'background-color:#FFF', 'position: fixed', 'top: 0', 'bottom: 0', 'left: 0', 'right: 0', 'margin: 0', 'padding:0', 'width: 100%', 'height: 100%', 'background:url(' + _options.image + ') no-repeat center', 'z-index:' + _options.z_index]
            var css = css_arr.join(';')
            var html = '<div id="' + _options.id + '" style="' + css + '"><div id="ajax_message">' + _options.message + '</div></div>'
            $(document).find('body').append(html)
        }
    }

    var _get = function(key) {
        return _options[key]
    }
    var _set = function(key, val) {
        if ($.isPlainObject(key)) {
            $.extend(_options, key)
        } else {
            _options[key] = val
        }
    }
    $(function() {
        $.loading = {
            init : _init,
            start : _start,
            end : _end,
            set : _set,
            get : _get,
        }
    })
})(window.Zepto || window.jQuery);
