(function($) {
    var _options = {
        disabled : false,
        running : false,
        prev_top : 0,
        threshold : 50,
        header : '#header',
        scroll_to_top : '#scroll_to_top',
        scroller : '#goods_list_contianer',
        get_more : _get_more,
        cb_get_more : _cb_get_more,
        indicator : '',
        indicator_id : 'scroll_indicator',
        init : _init_after_cb,
    }

    function _init(options) {
        _set(options)
        _init_indicator()
        bind_once($.scroll.get('scroller'), 'scroll', _check_top_position)
        bind_once($.scroll.get('scroll_to_top'), 'click', function() {
            $($.scroll.get('scroller')).scrollTop(0)
        })
    }

    function _init_indicator() {
        if ( typeof _options.indicator == 'undefined' || _options.indicator.length == 0) {
            _options.indicator = '<div style="display:none" id="' + _options.indicator_id + '">&nbsp;</div>'
        }
        if ($('#' + _options.indicator_id).length === 0) {
            $(_options.scroller).append(_options.indicator)
        }
    }

    var _set = function(key, val) {
        if ($.isPlainObject(key)) {
            $.extend(_options, key)
        } else {
            _options[key] = val
        }
    }
    function _check_top_position(event) {
        var scroll_top = $(_options.scroller).scrollTop()
        var scroll_height = $(_options.scroller).attr('scrollHeight')
        var window_height = $(window).height()

        if (_options.disabled === false && _options.running == false && scroll_top + window_height + _options.threshold >= scroll_height) {
            _options.get_more()
        }
        if (scroll_top > 100) {
            $(_options.scroll_to_top).show()
        } else {
            $(_options.scroll_to_top).hide()
        }

        if (scroll_top > 0 && scroll_top > _options.prev_top) {
            $(_options.header).addClass('headroom_hide')
        } else {
            $(_options.header).removeClass('headroom_hide')
        }
        _options.prev_top = scroll_top
    }

    function _get_more() {
        _options.running = true
        page_param['page']++
        page_param['is_full_page'] = 0
        page_callback = _options.cb_get_more
        page_loading = false
        _init_indicator()
        $('#' + _options.indicator_id).show()
        reload()
    }

    function _cb_get_more(data) {
        var json = parse_result(data)
        if (json) {
            _options.running = false
            if (json.error == ERR_END_OF_LIST) {
                $.scroll.disable(json.message)
            } else {
                var content = json.content
                if (page_param['page'] == 1) {
                    $(_options.scroller).html(content)
                } else {
                    $('#' + _options.indicator_id).before(content)
                }
                $('#' + _options.indicator_id).hide()
                _options.init()
            }
        }
    }

    function _init_after_cb() {
        init_goods()
    }

    function _get(key) {
        return _options[key]
    }

    function _enable() {
        $.scroll.set('disabled', false)
        $('#' + $.scroll.get('indicator_id')).removeClass('disabled')
    }

    function _disable(message) {
        $.scroll.set('disabled', true)
        $('#' + $.scroll.get('indicator_id')).addClass('disabled')
        $('#' + $.scroll.get('indicator_id')).html(message)
    }

    $(function() {
        $.scroll = {
            init : _init,
            set : _set,
            get : _get,
            enable : _enable,
            disable : _disable,
        }
    })
})(Zepto)
