/**
 * 分享插件
 */
(function($) {
    var _success = function() {
        open_toast('分享成功')
    }
    var _cancel = function() {
        open_toast('取消分享')
    }
    var _fail = function() {
        open_toast('分享失败')
    }
    var _get = function(key) {
        return _options[key]
    }
    var _set = function(key, val) {
        if ($.isPlainObject(key)) {
            $.extend(_options, key)
        } else {
            _options[key] = val
        }
    }
    var _empty = function() {

    }
    var _options = {
        success : _success,
        cancel : _cancel,
        fail : _fail,
    },
        _initialized
    /**
     * content包含的参数
     * @param {String} url
     * @param {String} title
     * @param {String} desc
     * @param {String} img
     */
    var _share = function(type, content) {
        switch(type) {
        //微信好友
        case 'weixin1':
            share_by_weixin(0, content)
            break
        //微信朋友圈
        case 'weixin2':
            share_by_weixin(1, content)
            break
        //短信
        case 'sms':
            share_by_sms(content)
            break
        case 'tsina':
            share_by_sina(content)
            break
        case 'qq':
            share_by_qq(content)
            break
        case 'qzone':
            share_by_qzone(content)
            break
        default:
            share_by_jiathis(type, content)
            break
        }
    }
    function cb_share(opId, dataType, data) {
        var result = arguments[(arguments.length - 1)]
        if (result == 0) {
            _options.success()
        } else if (result == 1) {
            _options.cancel()
        } else {
            _options.fail()
        }
    }

    function share_by_qq(content) {
        if (_.isEmpty(QQ_APP_ID)) {
            return false
        }
        var json = {
            title : content.title,
            summary : content.desc,
            targetUrl : content.url,
            imageUrl : content.img,
            cflag : '2',
        }
        uexQQ.shareWebImgTextToQQ(QQ_APP_ID, JSON.stringify(json))
    }

    function share_by_qzone(content) {
        if (_.isEmpty(QQ_APP_ID)) {
            share_by_jiathis('qzone', content)
            return false
        }
        var json = {
            title : content.title,
            summary : content.desc,
            targetUrl : content.url,
            imageUrl : [content.img],
        }
        uexQQ.shareImgTextToQZone(QQ_APP_ID, JSON.stringify(json))
    }

    function share_by_sina(content) {
        if (!_.isEmpty(WEIBO_APP_KEY) && !_.isEmpty(WEIBO_APP_SECRET) && !_.isEmpty(WEIBO_REGISTER_URL)) {
            uexSina.cbRegisterApp = function(opId, dataType, data) {
                if (data == 0) {
                    uexSina.cbShare = cb_share
                    //如果图片地址为http://...则必须在新浪申请高级权限
                    uexSina.sendImageContent(content.img, content.title + ' ' + content.desc)
                }
            }
            uexSina.registerApp(WEIBO_APP_KEY, WEIBO_APP_SECRET, WEIBO_REGISTER_URL)
        } else {
            share_by_jiathis('tsina', content)
        }
    }

    function share_by_weixin(type, content) {
        uexWeiXin.cbRegisterApp = function(opId, dataTpye, data) {
            if (data == 0) {
                var json = {
                    thumbImg : content.img,
                    wedpageUrl : content.url,
                    scene : type,
                    title : content.title,
                    description : content.desc,
                }
                uexWeiXin.shareLinkContent(JSON.stringify(json))
            } else {
                open_toast('微信插件注册失败')
            }
        }
        uexWeiXin.registerApp(WEIXIN_APP_ID)
    }

    function share_by_sms(content) {
        uexContact.cbMultiOpen = function(opCode, dataType, data) {
            if (dataType == 1) {
                var obj = JSON.parse(data)
                var user = ''
                for ( i = 0; i < obj.length; i++) {
                    if (i == 0) {
                        user = obj[i].num
                    } else {
                        user += "," + obj[i].num
                    }
                }
                uexSMS.open(user, content.title + '，' + content.url)
            }
        }
        uexContact.multiOpen()
    }

    function share_by_jiathis(type, content) {
        var url = 'http://www.jiathis.com/send/?webid=' + type + '&url=' + content.url + '&title=' + content.title
        switch(type) {
        case 'tsina':
            var type_name = '新浪微博'
            break
        case 'qzone':
            var type_name = 'QQ空间'
            break
        case 'tqq':
            var type_name = '腾讯微博'
            break
        case 'douban':
            var type_name = '豆瓣'
            break
        case 'renren':
            var type_name = '人人'
            break
        }
        open_page(url, _.uniqueId('share_' + type + '_'), '分享到' + type_name)
    }

    var _init = function(options) {
        if ( typeof options != 'undefined' && $.isPlainObject(options)) {
            $.extend(_options, options)
        }
        var win_json = {
            windowName : page_name,
        }
        uexWeiXin.setCallbackWindowName && uexWeiXin.setCallbackWindowName(JSON.stringify(win_json))
        uexWeiXin.cbShareLinkContent = cb_share
        uexQQ.cbShareQQ = function(opId, dataType, data) {
            var result = JSON.parse(data)
            var data = result.errCode
            cb_share(opId, dataType, data)
        }
        _initialized = true
    }

    $.share = {
        init : _init,
        set : _set,
        get : _get,
        share : _share,
    }
})(Zepto)
