(function($) {
    var _options = {
        sort : '.sort',
        resort : _resort,
        cb_resort : _cb_resort,
        label : '#sort_label',
        container : '#goods_list_container',
        init : init_goods,
    }
    var _order_label = {
        desc : '降序',
        asc : '升序'
    }
    function _init(options) {
        _set(options)
        bind_once($.sort.get('sort'), 'click', function() {
            _select_sort(this)
        })
    }

    var _get = function(key) {
        return _options[key]
    }
    var _set = function(key, val) {
        if ($.isPlainObject(key)) {
            $.extend(_options, key)
        } else {
            _options[key] = val
        }
    }
    function _select_sort(obj) {
        page_param['sort'] = $(obj).attr('sort')
        var cur_order = $(obj).attr('order')
        var label = $(obj).children().first().html()
        if (cur_order == 'DESC') {
            page_param['order'] = 'ASC'
        } else {
            page_param['order'] = 'DESC'
        }
        if (!_.isEmpty(label)) {
            var order_lable = _order_label[page_param['order'].toLowerCase()]
            $($.sort.get('label')).html(label + '&nbsp;' + order_lable)
        }
        $(_options.sort).each(function() {
            if ($(this).attr('sort') != page_param['sort']) {
                $(this).attr('order', 'ASC')
                $(this).children().first().removeClass('f-color-red')
                $(this).children().last().removeClass('DESC ASC')
            } else {
                $(this).attr('order', page_param['order'])
                if ($(this).find('.DESC').length == 0 && $(this).find('.ASC').length == 0) {
                    $(this).children().first().addClass('f-color-red')
                    $(this).children().last().addClass(page_param['order'])
                } else {
                    $(this).children().last().toggleClass('DESC ASC')
                }
            }
        })
        $('#filter_list_button').trigger('click')
        _options.resort()
    }

    function _resort() {
        if (page_param['sort'] == 'distance') {
            sort_by_distance()
        } else {
            page_param['page'] = 1
            page_param['is_full_page'] = 0
            page_loading = true
            page_callback = _options.cb_resort
            reload()
        }
    }

    function _cb_resort(data) {
        var json = parse_result(data)
        if (json) {
            var content = json.content
            if (page_param['page'] == 1) {
                $(_options.container).html(content)
            } else {
                $(_options.container).before(content)
            }
            _options.init()
        }
    }

    function sort_by_distance() {
        if (is_need_reloc()) {
            subscribe(CHANNEL_GET_ADDRESS, get_location_success, "sort")
            subscribe(CHANNEL_GET_ADDRESS_FAIL, get_location_fail, "sort")
            open_toast('定位中...', -1)
            get_address()
        } else {
            get_location_success()
        }
    }

    function get_location_success() {
        close_toast()
        var location = get_location()
        page_param['lat'] = location.lat
        page_param['log'] = location.log
        page_param['page'] = 1
        page_param['is_full_page'] = 0
        page_callback = $.sort.get('cb_resort')
        reload()
    }

    function get_location_fail() {
        open_toast('定位失败，无法使用距离排序')
    }

    $(function() {
        $.sort = {
            init : _init,
            set : _set,
            get : _get,
        }
    })
})(Zepto)